import click
import sys,random
import logging,os,configparser
from cryptography.hazmat.primitives.ciphers import Cipher, algorithms, modes
from cryptography.hazmat.backends import default_backend
from collections import OrderedDict
from cst import __version__ as version
from cst.csf import generate_csf
import cst.utils as utils
from cst.state import State,bstr

pass_environment = click.make_pass_decorator(State,ensure=True)
state = None

@click.group()
@click.version_option(version=version)
@click.option('--config-file','-cf',help='Path to config file.',default='./config.ini',type=click.Path(resolve_path=True))
@click.option('--config-name','-cn',default='DEFAULT')
@click.option('--verbose',default='info',help='Log Level. [Default = info]',type=click.Choice(['info','debug','warning','error'], case_sensitive=False))
@click.option('--log-file',help='Print log to file. [No log file generated by default.]',type=click.Path(resolve_path=True))
@click.pass_context
def run(ctx,config_file,config_name,verbose,log_file):
    utils.setup_logging(verbose)
    logger = logging.getLogger()
    logger.handlers = []
    ch = logging.StreamHandler()
    ch.setFormatter(utils.ColoredFormatter())
    logger.addHandler(ch)
    if (log_file):
        logger.info("Writing Log to file - " + str(log_file)+" .")
        fh = logging.FileHandler(log_file, 'w')
        logger.addHandler(fh)

    config = configparser.ConfigParser(empty_lines_in_values=False)
    if os.path.exists(config_file):
        password = click.prompt("Password for keys",hide_input=True)
        config.read(config_file)
        if config_name in config:
            state = State(config[config_name],password)
            ctx.obj=state
        else:
            logger.error("Invalid configuration name.")
    elif ctx.invoked_subcommand == 'init':
        password = click.prompt("Password for keys",hide_input=True,confirmation_prompt=True)
        if not os.path.exists(config_file):
            config[config_name] = {'db':os.path.abspath("./database.yaml"),'key_dir':os.path.abspath("./keys"),'crt_dir':os.path.abspath('./crts')}
            with open(config_file,"w") as cf:
                config.write(cf)
        config_dict = config[config_name]
        if not os.path.exists(config_dict['key_dir']):
            os.mkdir(config_dict['key_dir'])
        if not os.path.exists(config_dict['crt_dir']):
            os.mkdir(config_dict['crt_dir'])
        if not os.path.exists(config_dict['db']):
            os.mknod(config_dict['db'])
        ctx.obj=State(config[config_name],password)
    else:
        logger.error("Config file not found: "+config_file)
        raise SystemExit

@run.command(help="Initialise the necessary files and generate SRKs.")
@pass_environment
@click.pass_context
def init(ctx,state):
    logger = logging.getLogger(__name__)
    choice = click.prompt("Generate new CA key?",default='Y',type=click.Choice(['Y','n']),show_choices=True)
    if choice == 'Y':
        logger.info("Generating CA keys and Certificate.")
        state.gen_rsa_key("ca","ca",org="ORGANISATION NAME",ca_flag=True)
    num = 0
    while(num<1):
        num = click.prompt("Num of SRKs(Minimum 1)?",default=4,type=int)
    for i in range(num):
        state.gen_rsa_key("srk"+str(i),"ca",org="ORGANISATION NAME",ca_flag=True)
    state.gen_rsa_key("signk0.1","srk0",org="ORGANISATION NAME")
    ctx.invoke(gen_hcrt,names=tuple(["srk"+str(i) for i in range(num)]+["signk0.1"]))
    fuse_path = click.prompt("SRK Fuse File Path:",default='./fuse.bin',type=click.Path(resolve_path=True,writable=True))
    table_path = click.prompt("SRK Table File Path:",default='./table.bin',type=click.Path(resolve_path=True,writable=True))
    ctx.invoke(gen_srk_fuse,names=tuple(["srk"+str(i) for i in range(num)]),fuse_file=fuse_path,table_file=table_path)
    enc_boot = click.prompt("Run Setup for encryption support?",default='Y',type=click.Choice(['Y','n']),show_choices=True)
    if enc_boot == 'Y':
        logger.info("Running Setup for Encryption support")
        choice = click.prompt("Generate master key?",default='Y',type=click.Choice(['Y','n']),show_choices=True)
        path = None
        if choice == 'Y':
            path = click.prompt("Master Key File Path:",default='./mk.bin',type=click.Path(resolve_path=True,writable=True))
            ctx.invoke(gen_mk,output=path)
        ctx.invoke(gen_dek,name="dek1",master_key=path)


@run.group(help="Add a key to the database.")
def add_key():
    pass

@add_key.command(help="RSA key.")
@click.option('--name',required=True,type=str,help="Name to refer to in the Database.")
@click.option('--ca',required=True,type=str,help="Name of the Certifying authority in the Database.")
@click.option('--size',default=2048,help="Number of Bits in the RSA key.")
@click.option('--org',default='NAME',help="Name of Organisation.")
@click.option('--ca-flag',default=False,help="Use the certificate to sign other certificates.")
@click.option('--years',default=10,help="Number of years for validity of the certificate.")
@pass_environment
def rsa(state,name,ca,size,org,ca_flag,years):
    logger = logging.getLogger(__name__)
    if name in state.db:
        logger.error("Key Exists.")
        raise SystemExit
    if ca not in state.db:
        logger.error("CA doesnt exist.")
        raise SystemExit
    logger.info("Generating RSA key.")
    state.gen_rsa_key(name,ca,size=size,org=org,years=years,ca_flag=ca_flag)

@run.command(help="Generate the SRK table and SRK fuse value.")
@click.argument('names',nargs=-1)
@click.option('--fuse-file','-f',help='Name of the output Fuse file.',type=click.Path(resolve_path=True),default='./fuse.bin')
@click.option('--table-file','-t',help='Name of the output Table file.',type=click.Path(resolve_path=True))
@pass_environment
def gen_srk_fuse(state,names,fuse_file,table_file):
    logger = logging.getLogger(__name__)
    logger.info("Generating SRK Fuse.")
    table,fuse=state.gen_srk_table(names)
    logger.debug("Writing Fuse value to "+str(fuse_file))
    with open(fuse_file,"wb") as fuse_fd:
        fuse_fd.write(fuse)
    if table_file:
        logger.debug("Writing SRK Table to "+str(table_file))
        with open(table_file,"wb") as table_fd:
            table_fd.write(table)

@run.command(help="Generate HAB public key certificate for exisiting key pair.")
@click.argument('names',nargs=-1)
@pass_environment
def gen_hcrt(state,names):
    logger = logging.getLogger(__name__)
    for name in names:
        logger.info("Generating HAB cert for "+name)
        state.gen_hcrt(name)

@run.command(help="DEK related operations.")
@click.option("--bits","-b",default = 256,type=int,help="Number of bits in the key.")
@click.option("--output","-o",type=click.Path(resolve_path=True,writable=True),help="Path to output folder.",metavar="PATH")
@click.option("--master_key","-mk",type=click.Path(resolve_path=True,readable=True),help="Path to the Master Key",metavar="PATH")
@click.option('--name',type=str,default="dek", metavar = "NAME")
@pass_environment
def gen_dek(state,bits,output,master_key,name):
    logger = logging.getLogger(__name__)
    logger.info("Generating DEK")
    mapping = {256: 3,192: 2, 128: 1 }
    if name in state.db:
        logger.error("Name already exists.")
        raise SystemExit
    else:
        state.db[name] = {}
    dek = os.urandom(int(bits/8))
    if output:
        fpath = os.path.join(output,name+".bin")
    else:
        fpath = os.path.join(state.key_dir,name+".bin")
    state.write_sym_key(dek,fpath)
    state.db[name]['key'] = fpath
    if master_key:
        logger.info("Generating Encrypted Blob.")
        with open(master_key,"rb") as mfile:
            mkey = mfile.read()
        iv = os.urandom(16)
        cipher = Cipher(algorithms.AES(mkey), modes.CBC(iv),default_backend())
        encryptor = cipher.encryptor()
        ct = encryptor.update(dek) + encryptor.finalize()
        crt = bstr(mapping[bits],2)+bstr(0,2)+bstr(len(ct),2) + bstr(len(iv),2) + ct + iv
        ct_hash = state.hash(ct)
        encryptor = cipher.encryptor()
        ct_hash_enc = encryptor.update(ct_hash) + encryptor.finalize()
        crt = bstr(0x06,1)+bstr(len(crt),2) + crt + ct_hash_enc
        if output:
            crtpath = os.path.join(output,name+"_sec_entry.bin")
        else:
            crtpath = os.path.join(state.crt_dir,"dek_sec_entry.bin")
        with open(crtpath,"wb") as binfile:
            binfile.write(crt)
        state.db[name]['crt'] = crtpath

@run.command(help="DEK related operations.")
@click.option("--output","-o",type=click.Path(resolve_path=True,writable=True),help="Path to output file.",metavar="PATH",default="./mk.bin")
def gen_mk(output):
    logger = logging.getLogger(__name__)
    logger.info("Generating Master Key")
    mk = os.urandom(int(32))
    with open(output,"wb") as binfile:
        binfile.write(mk)

def check_xlen(ctx,param,value):
    from click import UsageError
    if value in [32,64]:
        return value
    else:
        raise UsageError("Invalid XLEN",ctx)
@run.command(help="Generate CSF binary.")
@click.option('--csf-file',required=True,type=click.Path(resolve_path=True,exists=True),help='Path to the csf file.')
@click.option('--xlen','-x',default=64,type=int,callback=check_xlen,help='XLEN of the system [32,64].')
@pass_environment
def gen_csf(state, csf_file,xlen):
    generate_csf(state,csf_file,xlen)
